"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.collectFileNames = void 0;
const path = __importStar(require("path"));
const glob_1 = require("./shared/glob");
const collectFileNames = (argv, cwd, include) => __awaiter(void 0, void 0, void 0, function* () {
    const globsAndNames = yield collectFileNamesFromGlobs(argv, cwd, include);
    if (!globsAndNames) {
        return undefined;
    }
    const [fileGlobs, fileNames] = globsAndNames;
    const implicitNodeModulesInclude = implicitNodeModulesIncluded(fileGlobs, fileNames);
    if (implicitNodeModulesInclude) {
        return `At least one path including node_modules was included implicitly: '${implicitNodeModulesInclude}'. Either adjust TypeStat's included files to not include node_modules (recommended) or explicitly include node_modules/ (not recommended).`;
    }
    return fileNames;
});
exports.collectFileNames = collectFileNames;
const collectFileNamesFromGlobs = (argv, cwd, include) => __awaiter(void 0, void 0, void 0, function* () {
    if (argv.args !== undefined && argv.args.length !== 0) {
        return [argv.args, yield glob_1.globAllAsync(argv.args)];
    }
    if (include === undefined) {
        return undefined;
    }
    return [include, yield glob_1.globAllAsync(include.map((subInclude) => path.join(cwd, subInclude)))];
});
const implicitNodeModulesIncluded = (fileGlobs, fileNames) => {
    return !fileGlobs.some((glob) => glob.includes("node_modules")) && (fileNames === null || fileNames === void 0 ? void 0 : fileNames.find((fileName) => fileName.includes("node_modules")));
};
//# sourceMappingURL=collectFileNames.js.map