"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getNewFileName = void 0;
const getNewFileName = (renameExtensions, oldFileName, readFile) => __awaiter(void 0, void 0, void 0, function* () {
    const oldExtension = oldFileName.substring(oldFileName.lastIndexOf("."));
    const beforeExtension = oldFileName.substring(0, oldFileName.length - oldExtension.length);
    if (typeof renameExtensions === "string") {
        return `${beforeExtension}.${renameExtensions}`;
    }
    const fileContents = (yield readFile(oldFileName)).toString();
    const fileContentsJoined = fileContents.replace(/ /g, "").replace(/"/g, "'");
    if (/(<\s*\/\s*[A-z\.]*\s*>)|(\/\s*>)/.test(fileContentsJoined)) {
        return `${beforeExtension}.tsx`;
    }
    return `${beforeExtension}.ts`;
});
exports.getNewFileName = getNewFileName;
//# sourceMappingURL=getNewFileName.js.map